Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.event
Class NamespaceReducer

    java.lang.Object
      net.sf.saxon.event.SequenceReceiver
          net.sf.saxon.event.ProxyReceiver
              net.sf.saxon.event.NamespaceReducer

All Implemented Interfaces:
  Result, Receiver, NamespaceResolver

    public class NamespaceReducer

extends ProxyReceiver
implements NamespaceResolver

NamespaceReducer is a ProxyReceiver responsible for removing duplicate namespace declarations. It also ensures that an xmlns="" undeclaration is output when necessary. Used on its own, the NamespaceReducer simply eliminates unwanted namespace declarations. It can also be subclassed, in which case the subclass can use the services of the NamespaceReducer to resolve QNames.

The NamespaceReducer also validates namespace-sensitive content.

Field Summary

Fields inherited from class net.sf.saxon.event.ProxyReceiver
`nextReceiver`

Fields inherited from class net.sf.saxon.event.SequenceReceiver
`pipelineConfiguration, previousAtomic, systemId`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`NamespaceReducer(Receiver next)` Create a NamespaceReducer

Method Summary
`void` | `endElement()` endElement: Discard the namespaces declared on this element.
`String` | `getURIForPrefix(String prefix, boolean useDefault)` Get the namespace URI corresponding to a given prefix.
`Iterator<String>` | `iteratePrefixes()` Get an iterator over all the prefixes declared in this namespace context.
`void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Output a namespace node (binding)
`void` | `startContent()` startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements
`void` | `startElement(NodeName elemName, SchemaType typeCode, int locationId, int properties)` startElement.

Methods inherited from class net.sf.saxon.event.ProxyReceiver
`append, attribute, characters, close, comment, endDocument, getNamePool, getUnderlyingReceiver, open, processingInstruction, setPipelineConfiguration, setSystemId, setUnderlyingReceiver, setUnparsedEntity, startDocument, usesTypeAnnotations`

Methods inherited from class net.sf.saxon.event.SequenceReceiver
`append, getConfiguration, getPipelineConfiguration, getSystemId`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NamespaceReducer

    public NamespaceReducer(Receiver next)

  Create a NamespaceReducer

  Parameters:
    `next` - the Receiver to which events will be passed after namespace reduction

Method Detail

### startElement

    public void startElement(NodeName elemName,
                             SchemaType typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  startElement. This call removes redundant namespace declarations, and possibly adds an xmlns="" undeclaration.

  Specified by:
    `startElement` in interface `Receiver`
  Overrides:
    `startElement` in class `ProxyReceiver`
  Parameters:
    `elemName` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - properties of the element node
  Throws:
    `XPathException` - if an error occurs

### namespace

    public void namespace(NamespaceBinding namespaceBinding,
                          int properties)
                   throws XPathException

  Output a namespace node (binding)

  Specified by:
    `namespace` in interface `Receiver`
  Overrides:
    `namespace` in class `ProxyReceiver`
  Parameters:
    `namespaceBinding` - the prefix/uri pair to be output
    `properties` - the properties of the namespace binding
  Throws:
    `XPathException` - if any downstream error occurs

### startContent

    public void startContent()
                      throws XPathException

  startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements

  Specified by:
    `startContent` in interface `Receiver`
  Overrides:
    `startContent` in class `ProxyReceiver`
  Throws:
    `XPathException` - if an error occurs

### endElement

    public void endElement()
                    throws XPathException

  endElement: Discard the namespaces declared on this element.

  Specified by:
    `endElement` in interface `Receiver`
  Overrides:
    `endElement` in class `ProxyReceiver`
  Throws:
    `XPathException` - if an error occurs

### getURIForPrefix

    public String getURIForPrefix(String prefix,
                                  boolean useDefault)

  Get the namespace URI corresponding to a given prefix. Return null if the prefix is not in scope.

  Specified by:
    `getURIForPrefix` in interface `NamespaceResolver`
  Parameters:
    `prefix` - the namespace prefix
    `useDefault` - true if the default namespace is to be used when the prefix is ""
  Returns:
    the uri for the namespace, or null if the prefix is not in scope

### iteratePrefixes

    public Iterator<String> iteratePrefixes()

  Get an iterator over all the prefixes declared in this namespace context. This will include the default namespace (prefix="") and the XML namespace where appropriate

  Specified by:
    `iteratePrefixes` in interface `NamespaceResolver`
  Returns:
    an iterator over all the prefixes for which a namespace binding exists, including the zero-length string to represent the null/absent prefix if it is bound

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.